/* convert.js - Utility for converting old format translation
 * Copyright (C) 2016 Jaypee
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
try {
(function () {

  var fs = require('fs');
  var path = require('path');

  var pathname = window.location.pathname;
  var app_index = path.dirname(path.normalize(pathname.slice(1)));
  var assets = app_index + '/data/others/translate/assets/';
  var text = fs.readFileSync(assets + 'en-US.json', 'utf-8');
  var json = JSON.parse(text);

  var converted = {};
  for (var prop in json) {
    var dict = json[prop];
    var array = [];
    for (var jp in dict) {
      var en = dict[jp];
      en = (en === jp) ? null : en;
      array.push({ key: jp, "en-US": en });
    }
    converted[prop] = array;
  }
  var output = JSON.stringify(converted, null, 2);
  fs.writeFileSync(assets + 'RJ162718.json', output);

})();
} catch (e) { console.error(e); }
